<?php

namespace app\api\controller\Subject;

use app\BaseController;
use app\common\model\Teachers_strength\Subject as ModelSubject;
use app\Request;
use think\Validate;
use think\exception\ValidateException;
use think\facade\Filesystem;
use app\common\arw\adjfut\src\Excel;
use app\common\arw\adjfut\src\UploadFile;
use think\facade\Db;
use app\common\exception\Tool;
use think\facade\Env;


class Subject extends BaseController
{
    /**
     * 获取授课科目列表
     */
    public function getSubjectList(Request $request): array
    {
        $params = $request->param();
        $con = [];

        $con = Tool::getOptionalQuery(['subject_name', 'LIKE'], ['subject_sort', '='],);

        $query = ModelSubject::where($con)
            ->field([
                'subject_id',
                'subject_guid',
                'subject_name',
                'subject_sort'
            ])
            ->order('subject_sort', 'asc');



        return msg("获取授课科目列表成功!", $query);
    }

    /**
     * 获取授课科目详情
     */
    public function getSubjectInfo(Request $request): array
    {
        $params = $request->param();

        $this->validate($params, ['subject_guid' => 'require']);

        $find = ModelSubject::field([
            'subject_id',
            'subject_guid',
            'subject_name',
            'subject_sort'
        ])
            ->where('subject_guid', $params['subject_guid'])
            ->find();

        return msg(0, '获取授课科目详情成功!', ['data' => $find]);
    }
}
