<?php

namespace app\common\model\ContactUs;

use app\common\arw\adjfut\src\Validate;
use app\BaseModel;
use think\model\concern\SoftDelete;
use app\common\arw\adjfut\src\Excel;
use app\Request;
use app\common\exception\Tool;
use think\facade\Db;

class ContactInfo extends BaseModel
{
    use SoftDelete;
    // 删除字段
    protected $deleteTime = 'contact_info_delete_time';
    // 设置主键名
    protected $pk = 'contact_info_guid';
    // 设置废弃字段
    protected $disuse = [];
    // 设置字段信息
    protected $schema = [

        "contact_info_id" => "int",

        "contact_info_guid" => "string",

        "contact_info_location" => "string",

        "latitude" => "string",

        "longitude" => "string",

        "customer_service_wx" => "string",

        "contact_info_phone" => "int",

        "join_apply_content" => "string",

        "contact_info_create_time" => "datetime",

        "contact_info_create_user_guid" => "string",

        "contact_info_update_time" => "datetime",

        "contact_info_update_user_guid" => "string",

        "contact_info_delete_time" => "datetime",

        "contact_info_delete_user_guid" => "string",

    ];
    // 设置json类型字段
    protected $json = [''];
    // 开启自动写入时间戳字段
    protected $autoWriteTimestamp = 'datetime';
    // 创建时间
    protected $createTime = 'contact_info_create_time';
    // 修改时间
    protected $updateTime = 'contact_info_update_time';




    /**
     * 新增前
     */
    public static function onBeforeInsert(self $model): void
    {
        // self::checkRepeatData($model);
        $model->completeCreateField();
    }

    /**
     * 更新前
     */
    public static function onBeforeUpdate(self $model): void
    {
        // self::checkRepeatData($model);
        $model->completeUpdateField();
    }

    /**
     * 删除前
     */
    public static function onBeforeDelete(self $model): void
    {
        $model->completeDeleteField();
    }
}
